

#include "BUILTIN.h"

#include "Nat.h"

#include "Real.h"
extern OBJ __ASeq_6;
extern OBJ _ACom_47(OBJ,OBJ);extern OBJ __ACom_47;
extern OBJ __AFileSystem_14;
extern OBJ __AFileSystem_16;
extern OBJ __AFileSystem_18;
extern OBJ _AFileSystem_191(OBJ);extern OBJ __AFileSystem_191;
extern OBJ _AFileSystem_193(OBJ,OBJ);extern OBJ __AFileSystem_193;

#include "Denotation.h"
extern OBJ __AOption_5;

#include "Char.h"

#include "Array.h"
extern OBJ _AArrayConv_3(OBJ);extern OBJ __AArrayConv_3;
extern OBJ _AComCompose_5(OBJ,OBJ);extern OBJ __AComCompose_5;

#include "ProcessCtrl.h"

#define __AProcessCtrl_Atimes_L120 __AProcessCtrl_120
#define _AProcessCtrl_Atimes_L120 _AProcessCtrl_120
#define AProcessCtrl_120 AProcessCtrl_Atimes_L120
extern OBJ __AProcessCtrl_Atimes_L120;
extern OBJ _AProcessCtrl_Atimes_L120(OBJ);

#define __AProcessCtrl_Auptime_L121 __AProcessCtrl_121
#define _AProcessCtrl_Auptime_L121 _AProcessCtrl_121
#define AProcessCtrl_121 AProcessCtrl_Auptime_L121
extern OBJ __AProcessCtrl_Auptime_L121;
extern OBJ _AProcessCtrl_Auptime_L121(OBJ);
OBJ __AProcessCtrl_Achild; /* child */
extern OBJ _AProcessCtrl_Achild_(OBJ);OBJ __AProcessCtrl_Achild_; /* child? */
extern OBJ _AProcessCtrl_Aparent(OBJ);OBJ __AProcessCtrl_Aparent; /* parent */
extern OBJ _AProcessCtrl_Aparent_(OBJ);OBJ __AProcessCtrl_Aparent_; /* parent? */
extern OBJ _AProcessCtrl_Achild_O1(OBJ);OBJ __AProcessCtrl_Achild_O1; /* child,1 */
OBJ __AProcessCtrl_Afailure; /* failure */
extern OBJ _AProcessCtrl_Afailure_(OBJ);OBJ __AProcessCtrl_Afailure_; /* failure? */
OBJ __AProcessCtrl_Asuccess; /* success */
extern OBJ _AProcessCtrl_Asuccess_(OBJ);OBJ __AProcessCtrl_Asuccess_; /* success? */
extern OBJ _AProcessCtrl_Sl(OBJ,OBJ);OBJ __AProcessCtrl_Sl; /* < */
extern OBJ _AProcessCtrl_Se(OBJ,OBJ);OBJ __AProcessCtrl_Se; /* = */
OBJ __AProcessCtrl_Afork; /* fork */
extern OBJ _AProcessCtrl_Aexit(OBJ);OBJ __AProcessCtrl_Aexit; /* exit */
extern OBJ _AProcessCtrl_Aexec(OBJ,OBJ);OBJ __AProcessCtrl_Aexec; /* exec */
extern OBJ _AProcessCtrl_AexecE(OBJ,OBJ,OBJ);OBJ __AProcessCtrl_AexecE; /* execE */
extern OBJ _AProcessCtrl_AexecP(OBJ,OBJ);OBJ __AProcessCtrl_AexecP; /* execP */
OBJ __AProcessCtrl_AgetPId; /* getPId */
OBJ __AProcessCtrl_AgetPPId; /* getPPId */
OBJ __AProcessCtrl_Aclock; /* clock */
OBJ __AProcessCtrl_Atimes; /* times */
OBJ __AProcessCtrl_Auptime; /* uptime */
OBJ __AProcessCtrl_Apause; /* pause */
extern OBJ _AProcessCtrl_Asleep(OBJ);OBJ __AProcessCtrl_Asleep; /* sleep */
extern OBJ _AProcessCtrl_AchDir(OBJ);OBJ __AProcessCtrl_AchDir; /* chDir */
OBJ __AProcessCtrl_AgetCWD; /* getCWD */
extern OBJ _AProcessCtrl_Aaccess(OBJ,OBJ);OBJ __AProcessCtrl_Aaccess; /* access */
extern OBJ _AProcessCtrl_Aumask(OBJ);OBJ __AProcessCtrl_Aumask; /* umask */
OBJ __AProcessCtrl_AgetUId; /* getUId */
OBJ __AProcessCtrl_AgetEUId; /* getEUId */
extern OBJ _AProcessCtrl_AsetUId(OBJ);OBJ __AProcessCtrl_AsetUId; /* setUId */
OBJ __AProcessCtrl_AgetGId; /* getGId */
OBJ __AProcessCtrl_AgetEGId; /* getEGId */
extern OBJ _AProcessCtrl_AsetGId(OBJ);OBJ __AProcessCtrl_AsetGId; /* setGId */
OBJ __AProcessCtrl_AgetPGrp; /* getPGrp */
OBJ __AProcessCtrl_AsetPGrp; /* setPGrp */
extern OBJ _AProcessCtrl_AsetPGrp_O1(OBJ,OBJ);OBJ __AProcessCtrl_AsetPGrp_O1; /* setPGrp,1 */
OBJ __AProcessCtrl_AsetSId; /* setSId */
OBJ __AProcessCtrl_AgetLogin; /* getLogin */
extern OBJ _AProcessCtrl_Ai_Atimes(OBJ,OBJ,OBJ,OBJ,OBJ);OBJ __AProcessCtrl_Ai_Atimes; /* i_times */
extern OBJ _AProcessCtrl_Ai_Atimes_(OBJ);OBJ __AProcessCtrl_Ai_Atimes_; /* i_times? */
extern OBJ _AProcessCtrl_Ai_Acstm(OBJ);OBJ __AProcessCtrl_Ai_Acstm; /* i_cstm */
extern OBJ _AProcessCtrl_Ai_Acutm(OBJ);OBJ __AProcessCtrl_Ai_Acutm; /* i_cutm */
extern OBJ _AProcessCtrl_Ai_Astm(OBJ);OBJ __AProcessCtrl_Ai_Astm; /* i_stm */
extern OBJ _AProcessCtrl_Ai_Autm(OBJ);OBJ __AProcessCtrl_Ai_Autm; /* i_utm */
extern OBJ _AProcessCtrl_Ai_Auptm(OBJ);OBJ __AProcessCtrl_Ai_Auptm; /* i_uptm */
OBJ __AProcessCtrl_Aexec_O1; /* exec,1 */
extern OBJ _AProcessCtrl_Aexec_(OBJ);OBJ __AProcessCtrl_Aexec_; /* exec? */
OBJ __AProcessCtrl_Awrite; /* write */
extern OBJ _AProcessCtrl_Awrite_(OBJ);OBJ __AProcessCtrl_Awrite_; /* write? */
OBJ __AProcessCtrl_Aread; /* read */
extern OBJ _AProcessCtrl_Aread_(OBJ);OBJ __AProcessCtrl_Aread_; /* read? */
extern OBJ _AProcessCtrl_Ahc_Afork(OBJ);OBJ __AProcessCtrl_Ahc_Afork; /* hc_fork */
extern OBJ _AProcessCtrl_Ahc_Aexit(OBJ,OBJ);OBJ __AProcessCtrl_Ahc_Aexit; /* hc_exit */
extern OBJ _AProcessCtrl_Ahc_Aexecv(OBJ,OBJ,OBJ);OBJ __AProcessCtrl_Ahc_Aexecv; /* hc_execv */
extern OBJ _AProcessCtrl_Ahc_Aexecve(OBJ,OBJ,OBJ,OBJ);OBJ __AProcessCtrl_Ahc_Aexecve; /* hc_execve */
extern OBJ _AProcessCtrl_Ahc_Aexecvp(OBJ,OBJ,OBJ);OBJ __AProcessCtrl_Ahc_Aexecvp; /* hc_execvp */
extern OBJ _AProcessCtrl_Ahc_Agetpid(OBJ);OBJ __AProcessCtrl_Ahc_Agetpid; /* hc_getpid */
extern OBJ _AProcessCtrl_Ahc_Agetppid(OBJ);OBJ __AProcessCtrl_Ahc_Agetppid; /* hc_getppid */
extern OBJ _AProcessCtrl_Ahc_Aclock(OBJ);OBJ __AProcessCtrl_Ahc_Aclock; /* hc_clock */
extern OBJ _AProcessCtrl_Ahc_Atimes(OBJ);OBJ __AProcessCtrl_Ahc_Atimes; /* hc_times */
extern OBJ _AProcessCtrl_Ahc_Apause(OBJ);OBJ __AProcessCtrl_Ahc_Apause; /* hc_pause */
extern OBJ _AProcessCtrl_Ahc_Asleep(OBJ,OBJ);OBJ __AProcessCtrl_Ahc_Asleep; /* hc_sleep */
extern OBJ _AProcessCtrl_Ahc_Achdir(OBJ,OBJ);OBJ __AProcessCtrl_Ahc_Achdir; /* hc_chdir */
extern OBJ _AProcessCtrl_Ahc_Agetcwd(OBJ);OBJ __AProcessCtrl_Ahc_Agetcwd; /* hc_getcwd */
extern OBJ _AProcessCtrl_Ahc_Aaccess(OBJ,OBJ,OBJ);OBJ __AProcessCtrl_Ahc_Aaccess; /* hc_access */
extern OBJ _AProcessCtrl_Ahc_Aumask(OBJ,OBJ);OBJ __AProcessCtrl_Ahc_Aumask; /* hc_umask */
extern OBJ _AProcessCtrl_Ahc_Agetuid(OBJ);OBJ __AProcessCtrl_Ahc_Agetuid; /* hc_getuid */
extern OBJ _AProcessCtrl_Ahc_Ageteuid(OBJ);OBJ __AProcessCtrl_Ahc_Ageteuid; /* hc_geteuid */
extern OBJ _AProcessCtrl_Ahc_Asetuid(OBJ,OBJ);OBJ __AProcessCtrl_Ahc_Asetuid; /* hc_setuid */
extern OBJ _AProcessCtrl_Ahc_Agetgid(OBJ);OBJ __AProcessCtrl_Ahc_Agetgid; /* hc_getgid */
extern OBJ _AProcessCtrl_Ahc_Agetegid(OBJ);OBJ __AProcessCtrl_Ahc_Agetegid; /* hc_getegid */
extern OBJ _AProcessCtrl_Ahc_Asetgid(OBJ,OBJ);OBJ __AProcessCtrl_Ahc_Asetgid; /* hc_setgid */
extern OBJ _AProcessCtrl_Ahc_Agetpgrp(OBJ);OBJ __AProcessCtrl_Ahc_Agetpgrp; /* hc_getpgrp */
extern OBJ _AProcessCtrl_Ahc_Asetpgid(OBJ,OBJ,OBJ);OBJ __AProcessCtrl_Ahc_Asetpgid; /* hc_setpgid */
extern OBJ _AProcessCtrl_Ahc_Asetsid(OBJ);OBJ __AProcessCtrl_Ahc_Asetsid; /* hc_setsid */
extern OBJ _AProcessCtrl_Ahc_Agetlogin(OBJ);OBJ __AProcessCtrl_Ahc_Agetlogin; /* hc_getlogin */
extern OBJ _AProcessCtrl_Atimes_L120(OBJ);OBJ __AProcessCtrl_Atimes_L120; /* times'120 */
extern OBJ _AProcessCtrl_Auptime_L121(OBJ);OBJ __AProcessCtrl_Auptime_L121; /* uptime'121 */

#include "ProcessCtrl.hc.c"

extern OBJ _AProcessCtrl_Achild_(OBJ x1) /* child? */
{OBJ r;
 if(ISPRM(x1)){
  r=__ABUILTIN_5;
 }else{
  if(EXPRD(x1,1)){
   FREE(FLD1(x1,1),1);DSPRDF(x1);
  }else{
   DCPRD(x1,1);}
  r=__ABUILTIN_3;}
 return r;}

extern OBJ _AProcessCtrl_Aparent(OBJ x1) /* parent */
{OBJ r;
 PRD1(1,r);FLD1(r,1)=x1;
 return r;}

extern OBJ _AProcessCtrl_Aparent_(OBJ x1) /* parent? */
{OBJ r;
 if(ISPRM(x1)){
  r=__ABUILTIN_3;
 }else{
  if(EXPRD(x1,1)){
   FREE(FLD1(x1,1),1);DSPRDF(x1);
  }else{
   DCPRD(x1,1);}
  r=__ABUILTIN_5;}
 return r;}

extern OBJ _AProcessCtrl_Achild_O1(OBJ x1) /* child,1 */
{OBJ r;
 if(ISPRM(x1)){
  HLT("ProcessCtrl at <unknown> : undefined selection child\'ProcessCtrl:fission->process");
 }else{
  {OBJ x2=FLD1(x1,1);
   if(EXPRD(x1,1)){
    r=x2;
    DSPRDF(x1);
   }else{
    COPY(x2,1);
    r=x2;
    FRPRD(x1,1);}}}
 return r;}

extern OBJ _AProcessCtrl_Afailure_(OBJ x1) /* failure? */
{OBJ r;
 if(ISTGPRM(x1,1)){
  r=__ABUILTIN_5;
 }else{
  r=__ABUILTIN_3;}
 return r;}

extern OBJ _AProcessCtrl_Asuccess_(OBJ x1) /* success? */
{OBJ r;
 if(ISTGPRM(x1,0)){
  r=__ABUILTIN_5;
 }else{
  r=__ABUILTIN_3;}
 return r;}

extern OBJ _AProcessCtrl_Aexit(OBJ x1) /* exit */
{OBJ r;
 CPCLS(__AProcessCtrl_Ahc_Aexit,1);
 {OBJ x2;
  x2=(*(OBJ(*)(OBJ,OBJ))METHOD(__AProcessCtrl_Ahc_Aexit,1))(__AProcessCtrl_Ahc_Aexit,x1);
  PRD(2,0,r);FLD(r,1)=x2;FLD(r,2)=__ASeq_6;}
 return r;}

extern OBJ _AProcessCtrl_Aexec(OBJ x1,OBJ x2) /* exec */
{OBJ r;
 CPCLS(__AProcessCtrl_Ahc_Aexecv,1);
 {OBJ x3;OBJ x4;
  x3=_AArrayConv_3(x2);
  x4=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(__AProcessCtrl_Ahc_Aexecv,2))(__AProcessCtrl_Ahc_Aexecv,x1,x3);
  PRD(2,0,r);FLD(r,1)=x4;FLD(r,2)=__ASeq_6;}
 return r;}

extern OBJ _AProcessCtrl_AexecE(OBJ x1,OBJ x2,OBJ x3) /* execE */
{OBJ r;
 CPCLS(__AProcessCtrl_Ahc_Aexecve,1);
 {OBJ x4;OBJ x5;OBJ x6;
  x4=_AArrayConv_3(x2);
  x5=_AArrayConv_3(x3);
  x6=(*(OBJ(*)(OBJ,OBJ,OBJ,OBJ))METHOD(__AProcessCtrl_Ahc_Aexecve,3))(__AProcessCtrl_Ahc_Aexecve,x1,x4,x5);
  PRD(2,0,r);FLD(r,1)=x6;FLD(r,2)=__ASeq_6;}
 return r;}

extern OBJ _AProcessCtrl_AexecP(OBJ x1,OBJ x2) /* execP */
{OBJ r;
 CPCLS(__AProcessCtrl_Ahc_Aexecvp,1);
 {OBJ x3;OBJ x4;
  x3=_AArrayConv_3(x2);
  x4=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(__AProcessCtrl_Ahc_Aexecvp,2))(__AProcessCtrl_Ahc_Aexecvp,x1,x3);
  PRD(2,0,r);FLD(r,1)=x4;FLD(r,2)=__ASeq_6;}
 return r;}

extern OBJ _AProcessCtrl_Asleep(OBJ x1) /* sleep */
{OBJ r;
 CPCLS(__AProcessCtrl_Ahc_Asleep,1);
 {OBJ x2;
  x2=(*(OBJ(*)(OBJ,OBJ))METHOD(__AProcessCtrl_Ahc_Asleep,1))(__AProcessCtrl_Ahc_Asleep,x1);
  PRD(2,0,r);FLD(r,1)=x2;FLD(r,2)=__ASeq_6;}
 return r;}

extern OBJ _AProcessCtrl_AchDir(OBJ x1) /* chDir */
{OBJ r;
 CPCLS(__AProcessCtrl_Ahc_Achdir,1);
 {OBJ x2;
  x2=(*(OBJ(*)(OBJ,OBJ))METHOD(__AProcessCtrl_Ahc_Achdir,1))(__AProcessCtrl_Ahc_Achdir,x1);
  PRD(2,0,r);FLD(r,1)=x2;FLD(r,2)=__ASeq_6;}
 return r;}

extern OBJ _AProcessCtrl_Aaccess(OBJ x1,OBJ x2) /* access */
{OBJ r;
 COPY(x2,1);
 {OBJ x3;OBJ x4;OBJ x5;OBJ x6;
  x3=_AFileSystem_193(x2,__AFileSystem_18);
  x4=_AFileSystem_193(x3,__AFileSystem_16);
  x5=_AFileSystem_193(x4,__AFileSystem_14);
  x6=_AFileSystem_191(x5);
  if(ISTGPRM(x6,1)){
   CPCLS(__AProcessCtrl_Ahc_Aaccess,1);
   {OBJ x7;
    x7=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(__AProcessCtrl_Ahc_Aaccess,2))(__AProcessCtrl_Ahc_Aaccess,x1,x2);
    PRD(2,0,r);FLD(r,1)=x7;FLD(r,2)=__ASeq_6;}
  }else{
   HLT("access\'ProcessCtrl: Only owner... permission may appear");}}
 return r;}

extern OBJ _AProcessCtrl_Aumask(OBJ x1) /* umask */
{OBJ r;
 CPCLS(__AProcessCtrl_Ahc_Aumask,1);
 {OBJ x2;
  x2=(*(OBJ(*)(OBJ,OBJ))METHOD(__AProcessCtrl_Ahc_Aumask,1))(__AProcessCtrl_Ahc_Aumask,x1);
  PRD(2,0,r);FLD(r,1)=x2;FLD(r,2)=__ASeq_6;}
 return r;}

extern OBJ _AProcessCtrl_AsetUId(OBJ x1) /* setUId */
{OBJ r;
 CPCLS(__AProcessCtrl_Ahc_Asetuid,1);
 {OBJ x2;
  x2=(*(OBJ(*)(OBJ,OBJ))METHOD(__AProcessCtrl_Ahc_Asetuid,1))(__AProcessCtrl_Ahc_Asetuid,x1);
  PRD(2,0,r);FLD(r,1)=x2;FLD(r,2)=__ASeq_6;}
 return r;}

extern OBJ _AProcessCtrl_AsetGId(OBJ x1) /* setGId */
{OBJ r;
 CPCLS(__AProcessCtrl_Ahc_Asetgid,1);
 {OBJ x2;
  x2=(*(OBJ(*)(OBJ,OBJ))METHOD(__AProcessCtrl_Ahc_Asetgid,1))(__AProcessCtrl_Ahc_Asetgid,x1);
  PRD(2,0,r);FLD(r,1)=x2;FLD(r,2)=__ASeq_6;}
 return r;}

extern OBJ _AProcessCtrl_AsetPGrp_O1(OBJ x1,OBJ x2) /* setPGrp,1 */
{OBJ r;
 CPCLS(__AProcessCtrl_Ahc_Asetpgid,1);
 {OBJ x3;OBJ x4;OBJ x5;
  PRD1(1,x3);FLD1(x3,1)=x1;
  PRD1(1,x4);FLD1(x4,1)=x2;
  x5=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(__AProcessCtrl_Ahc_Asetpgid,2))(__AProcessCtrl_Ahc_Asetpgid,x3,x4);
  PRD(2,0,r);FLD(r,1)=x5;FLD(r,2)=__ASeq_6;}
 return r;}

extern OBJ _AProcessCtrl_Ai_Atimes(OBJ x1,OBJ x2,OBJ x3,OBJ x4,OBJ x5) /* i_times */
{OBJ r;
 PRD1(5,r);FLD1(r,1)=x1;FLD1(r,2)=x2;FLD1(r,3)=x3;FLD1(r,4)=x4;FLD1(r,5)=x5;
 return r;}

extern OBJ _AProcessCtrl_Ai_Atimes_(OBJ x1) /* i_times? */
{OBJ r;
 FRPRD(x1,1);
 r=__ABUILTIN_5;
 return r;}

extern OBJ _AProcessCtrl_Ai_Acstm(OBJ x1) /* i_cstm */
{OBJ r;
 {OBJ x6=FLD1(x1,5);
  if(EXPRD(x1,1)){
   r=x6;
   FLD1(x1,5)=NIL;DSPRD(x1);
  }else{
   CPPRD(x6,1);
   r=x6;
   FRPRD(x1,1);}}
 return r;}

extern OBJ _AProcessCtrl_Ai_Acutm(OBJ x1) /* i_cutm */
{OBJ r;
 {OBJ x5=FLD1(x1,4);
  if(EXPRD(x1,1)){
   r=x5;
   FLD1(x1,4)=NIL;DSPRD(x1);
  }else{
   CPPRD(x5,1);
   r=x5;
   FRPRD(x1,1);}}
 return r;}

extern OBJ _AProcessCtrl_Ai_Astm(OBJ x1) /* i_stm */
{OBJ r;
 {OBJ x4=FLD1(x1,3);
  if(EXPRD(x1,1)){
   r=x4;
   FLD1(x1,3)=NIL;DSPRD(x1);
  }else{
   CPPRD(x4,1);
   r=x4;
   FRPRD(x1,1);}}
 return r;}

extern OBJ _AProcessCtrl_Ai_Autm(OBJ x1) /* i_utm */
{OBJ r;
 {OBJ x3=FLD1(x1,2);
  if(EXPRD(x1,1)){
   r=x3;
   FLD1(x1,2)=NIL;DSPRD(x1);
  }else{
   CPPRD(x3,1);
   r=x3;
   FRPRD(x1,1);}}
 return r;}

extern OBJ _AProcessCtrl_Ai_Auptm(OBJ x1) /* i_uptm */
{OBJ r;
 {OBJ x2=FLD1(x1,1);
  if(EXPRD(x1,1)){
   r=x2;
   FLD1(x1,1)=NIL;DSPRD(x1);
  }else{
   CPPRD(x2,1);
   r=x2;
   FRPRD(x1,1);}}
 return r;}

extern OBJ _AProcessCtrl_Aexec_(OBJ x1) /* exec? */
{OBJ r;
 if(ISTGPRM(x1,2)){
  r=__ABUILTIN_5;
 }else{
  r=__ABUILTIN_3;}
 return r;}

extern OBJ _AProcessCtrl_Awrite_(OBJ x1) /* write? */
{OBJ r;
 if(ISTGPRM(x1,1)){
  r=__ABUILTIN_5;
 }else{
  r=__ABUILTIN_3;}
 return r;}

extern OBJ _AProcessCtrl_Aread_(OBJ x1) /* read? */
{OBJ r;
 if(ISTGPRM(x1,0)){
  r=__ABUILTIN_5;
 }else{
  r=__ABUILTIN_3;}
 return r;}

extern OBJ _AProcessCtrl_Atimes_L120(OBJ x1) /* times'120 */
{OBJ r;
 {OBJ x30=FLD1(x1,2);OBJ x31=FLD1(x1,3);OBJ x32=FLD1(x1,4);OBJ x33=FLD1(x1,5);
  if(EXPRD(x1,1)){
   FRPRD(FLD1(x1,1),1);DSPRDF(x1);
  }else{
   CPPRD(x30,1);CPPRD(x31,1);CPPRD(x32,1);CPPRD(x33,1);
   FRPRD(x1,1);}
  CPCLS(__ACom_47,1);
  {OBJ x34;OBJ x35;OBJ x36;
   PRD1(4,x34);FLD1(x34,1)=x30;FLD1(x34,2)=x31;FLD1(x34,3)=x32;FLD1(x34,4)=x33;
   PRD(1,0,x35);FLD(x35,1)=x34;
   x36=(*(OBJ(*)(OBJ,OBJ))METHOD(__ACom_47,1))(__ACom_47,x35);
   PRD(2,0,r);FLD(r,1)=x36;FLD(r,2)=__ASeq_6;}}
 return r;}

extern OBJ _AProcessCtrl_Auptime_L121(OBJ x1) /* uptime'121 */
{OBJ r;
 {OBJ x2=FLD1(x1,1);
  if(EXPRD(x1,1)){
   FLD1(x1,1)=NIL;DSPRD(x1);
  }else{
   CPPRD(x2,1);
   FRPRD(x1,1);}
  CPCLS(__ACom_47,1);
  {OBJ x7;OBJ x8;OBJ x9;
   x7=x2;
   PRD(1,0,x8);FLD(x8,1)=x7;
   x9=(*(OBJ(*)(OBJ,OBJ))METHOD(__ACom_47,1))(__ACom_47,x8);
   PRD(2,0,r);FLD(r,1)=x9;FLD(r,2)=__ASeq_6;}}
 return r;}








static void ___AProcessCtrl_23()
{
 /* __AProcessCtrl_Atimes */
 CPCLS(__AProcessCtrl_Ahc_Atimes,1);
 CPCLS(__AProcessCtrl_Atimes_L120,1);
 {OBJ x1;
  PRD(2,0,x1);FLD(x1,1)=__AProcessCtrl_Ahc_Atimes;FLD(x1,2)=__ASeq_6;
  __AProcessCtrl_Atimes=_AComCompose_5(x1,__AProcessCtrl_Atimes_L120);}}

static void ___AProcessCtrl_24()
{
 /* __AProcessCtrl_Auptime */
 CPCLS(__AProcessCtrl_Ahc_Atimes,1);
 CPCLS(__AProcessCtrl_Auptime_L121,1);
 {OBJ x1;
  PRD(2,0,x1);FLD(x1,1)=__AProcessCtrl_Ahc_Atimes;FLD(x1,2)=__ASeq_6;
  __AProcessCtrl_Auptime=_AComCompose_5(x1,__AProcessCtrl_Auptime_L121);}}








static void ___AProcessCtrl_38()
{
 /* __AProcessCtrl_AsetPGrp */
 CPCLS(__AProcessCtrl_Ahc_Asetpgid,1);
 {OBJ x1;
  x1=(*(OBJ(*)(OBJ,OBJ,OBJ))METHOD(__AProcessCtrl_Ahc_Asetpgid,2))(__AProcessCtrl_Ahc_Asetpgid,__AOption_5,__AOption_5);
  PRD(2,0,__AProcessCtrl_AsetPGrp);FLD(__AProcessCtrl_AsetPGrp,1)=x1;FLD(__AProcessCtrl_AsetPGrp,2)=__ASeq_6;}}






init_AProcessCtrl()
{
 static int visited=0; if(visited) return; visited=1;
 init_AVoid();
 init_ANat();
 init_AReal();
 init_AQuadruple();
 init_ASeq();
 init_ACom();
 init_AFileSystem();
 init_AUserAndGroup();
 init_ADenotation();
 init_AOption();
 init_ASet();
 init_AChar();
 init_AString();
 init_ATime();
 init_AArray();
 init_AArrayConv();
 init_AComCompose();
 init_ASeqMap();
 init_AOptionMap();
 init_AArrayReduce();
 CLS(1,_AProcessCtrl_95,__AProcessCtrl_95);
 CLS(1,_AProcessCtrl_30,__AProcessCtrl_30);
 CLS(2,_AProcessCtrl_29,__AProcessCtrl_29);
 CLS(1,_AProcessCtrl_27,__AProcessCtrl_27);
 CLS(1,_AProcessCtrl_26,__AProcessCtrl_26);
 CLS(1,_AProcessCtrl_121,__AProcessCtrl_121);
 CLS(1,_AProcessCtrl_120,__AProcessCtrl_120);
 CLS(1,_AProcessCtrl_56,__AProcessCtrl_56);
 CLS(1,_AProcessCtrl_119,__AProcessCtrl_119);
 CLS(1,_AProcessCtrl_118,__AProcessCtrl_118);
 CLS(1,_AProcessCtrl_54,__AProcessCtrl_54);
 CLS(3,_AProcessCtrl_117,__AProcessCtrl_117);
 CLS(1,_AProcessCtrl_116,__AProcessCtrl_116);
 CLS(1,_AProcessCtrl_52,__AProcessCtrl_52);
 CLS(2,_AProcessCtrl_115,__AProcessCtrl_115);
 CLS(2,_AProcessCtrl_19,__AProcessCtrl_19);
 CLS(3,_AProcessCtrl_18,__AProcessCtrl_18);
 CLS(1,_AProcessCtrl_114,__AProcessCtrl_114);
 CLS(1,_AProcessCtrl_113,__AProcessCtrl_113);
 CLS(2,_AProcessCtrl_17,__AProcessCtrl_17);
 CLS(1,_AProcessCtrl_49,__AProcessCtrl_49);
 CLS(2,_AProcessCtrl_112,__AProcessCtrl_112);
 CLS(1,_AProcessCtrl_16,__AProcessCtrl_16);
 CLS(1,_AProcessCtrl_48,__AProcessCtrl_48);
 CLS(1,_AProcessCtrl_111,__AProcessCtrl_111);
 CLS(1,_AProcessCtrl_47,__AProcessCtrl_47);
 CLS(1,_AProcessCtrl_110,__AProcessCtrl_110);
 CLS(2,_AProcessCtrl_14,__AProcessCtrl_14);
 CLS(1,_AProcessCtrl_46,__AProcessCtrl_46);
 CLS(2,_AProcessCtrl_109,__AProcessCtrl_109);
 CLS(2,_AProcessCtrl_13,__AProcessCtrl_13);
 CLS(1,_AProcessCtrl_45,__AProcessCtrl_45);
 CLS(1,_AProcessCtrl_44,__AProcessCtrl_44);
 CLS(3,_AProcessCtrl_108,__AProcessCtrl_108);
 CLS(1,_AProcessCtrl_107,__AProcessCtrl_107);
 CLS(1,_AProcessCtrl_11,__AProcessCtrl_11);
 CLS(5,_AProcessCtrl_43,__AProcessCtrl_43);
 CLS(2,_AProcessCtrl_106,__AProcessCtrl_106);
 CLS(2,_AProcessCtrl_105,__AProcessCtrl_105);
 CLS(1,_AProcessCtrl_9,__AProcessCtrl_9);
 CLS(1,_AProcessCtrl_104,__AProcessCtrl_104);
 CLS(2,_AProcessCtrl_39,__AProcessCtrl_39);
 CLS(1,_AProcessCtrl_103,__AProcessCtrl_103);
 CLS(1,_AProcessCtrl_102,__AProcessCtrl_102);
 CLS(1,_AProcessCtrl_6,__AProcessCtrl_6);
 CLS(1,_AProcessCtrl_101,__AProcessCtrl_101);
 CLS(1,_AProcessCtrl_5,__AProcessCtrl_5);
 CLS(1,_AProcessCtrl_100,__AProcessCtrl_100);
 CLS(1,_AProcessCtrl_4,__AProcessCtrl_4);
 CLS(1,_AProcessCtrl_36,__AProcessCtrl_36);
 CLS(3,_AProcessCtrl_99,__AProcessCtrl_99);
 CLS(1,_AProcessCtrl_3,__AProcessCtrl_3);
 CLS(4,_AProcessCtrl_98,__AProcessCtrl_98);
 CLS(1,_AProcessCtrl_33,__AProcessCtrl_33);
 CLS(3,_AProcessCtrl_97,__AProcessCtrl_97);
 CLS(2,_AProcessCtrl_96,__AProcessCtrl_96);
 init_const_AProcessCtrl();
 /* __AProcessCtrl_Achild */
 PRM1(__AProcessCtrl_Achild);
 /* __AProcessCtrl_Afailure */
 PRM(1,__AProcessCtrl_Afailure);
 /* __AProcessCtrl_Asuccess */
 PRM(0,__AProcessCtrl_Asuccess);
 /* __AProcessCtrl_Afork */
 CPCLS(__AProcessCtrl_Ahc_Afork,1);
 PRD(2,0,__AProcessCtrl_Afork);FLD(__AProcessCtrl_Afork,1)=__AProcessCtrl_Ahc_Afork;FLD(__AProcessCtrl_Afork,2)=__ASeq_6;
 /* __AProcessCtrl_AgetPId */
 CPCLS(__AProcessCtrl_Ahc_Agetpid,1);
 PRD(2,0,__AProcessCtrl_AgetPId);FLD(__AProcessCtrl_AgetPId,1)=__AProcessCtrl_Ahc_Agetpid;FLD(__AProcessCtrl_AgetPId,2)=__ASeq_6;
 /* __AProcessCtrl_AgetPPId */
 CPCLS(__AProcessCtrl_Ahc_Agetppid,1);
 PRD(2,0,__AProcessCtrl_AgetPPId);FLD(__AProcessCtrl_AgetPPId,1)=__AProcessCtrl_Ahc_Agetppid;FLD(__AProcessCtrl_AgetPPId,2)=__ASeq_6;
 /* __AProcessCtrl_Aclock */
 CPCLS(__AProcessCtrl_Ahc_Aclock,1);
 PRD(2,0,__AProcessCtrl_Aclock);FLD(__AProcessCtrl_Aclock,1)=__AProcessCtrl_Ahc_Aclock;FLD(__AProcessCtrl_Aclock,2)=__ASeq_6;
 ___AProcessCtrl_23();
 ___AProcessCtrl_24();
 /* __AProcessCtrl_Apause */
 CPCLS(__AProcessCtrl_Ahc_Apause,1);
 PRD(2,0,__AProcessCtrl_Apause);FLD(__AProcessCtrl_Apause,1)=__AProcessCtrl_Ahc_Apause;FLD(__AProcessCtrl_Apause,2)=__ASeq_6;
 /* __AProcessCtrl_AgetCWD */
 CPCLS(__AProcessCtrl_Ahc_Agetcwd,1);
 PRD(2,0,__AProcessCtrl_AgetCWD);FLD(__AProcessCtrl_AgetCWD,1)=__AProcessCtrl_Ahc_Agetcwd;FLD(__AProcessCtrl_AgetCWD,2)=__ASeq_6;
 /* __AProcessCtrl_AgetUId */
 CPCLS(__AProcessCtrl_Ahc_Agetuid,1);
 PRD(2,0,__AProcessCtrl_AgetUId);FLD(__AProcessCtrl_AgetUId,1)=__AProcessCtrl_Ahc_Agetuid;FLD(__AProcessCtrl_AgetUId,2)=__ASeq_6;
 /* __AProcessCtrl_AgetEUId */
 CPCLS(__AProcessCtrl_Ahc_Ageteuid,1);
 PRD(2,0,__AProcessCtrl_AgetEUId);FLD(__AProcessCtrl_AgetEUId,1)=__AProcessCtrl_Ahc_Ageteuid;FLD(__AProcessCtrl_AgetEUId,2)=__ASeq_6;
 /* __AProcessCtrl_AgetGId */
 CPCLS(__AProcessCtrl_Ahc_Agetgid,1);
 PRD(2,0,__AProcessCtrl_AgetGId);FLD(__AProcessCtrl_AgetGId,1)=__AProcessCtrl_Ahc_Agetgid;FLD(__AProcessCtrl_AgetGId,2)=__ASeq_6;
 /* __AProcessCtrl_AgetEGId */
 CPCLS(__AProcessCtrl_Ahc_Agetegid,1);
 PRD(2,0,__AProcessCtrl_AgetEGId);FLD(__AProcessCtrl_AgetEGId,1)=__AProcessCtrl_Ahc_Agetegid;FLD(__AProcessCtrl_AgetEGId,2)=__ASeq_6;
 /* __AProcessCtrl_AgetPGrp */
 CPCLS(__AProcessCtrl_Ahc_Agetpgrp,1);
 PRD(2,0,__AProcessCtrl_AgetPGrp);FLD(__AProcessCtrl_AgetPGrp,1)=__AProcessCtrl_Ahc_Agetpgrp;FLD(__AProcessCtrl_AgetPGrp,2)=__ASeq_6;
 ___AProcessCtrl_38();
 /* __AProcessCtrl_AsetSId */
 CPCLS(__AProcessCtrl_Ahc_Asetsid,1);
 PRD(2,0,__AProcessCtrl_AsetSId);FLD(__AProcessCtrl_AsetSId,1)=__AProcessCtrl_Ahc_Asetsid;FLD(__AProcessCtrl_AsetSId,2)=__ASeq_6;
 /* __AProcessCtrl_AgetLogin */
 CPCLS(__AProcessCtrl_Ahc_Agetlogin,1);
 PRD(2,0,__AProcessCtrl_AgetLogin);FLD(__AProcessCtrl_AgetLogin,1)=__AProcessCtrl_Ahc_Agetlogin;FLD(__AProcessCtrl_AgetLogin,2)=__ASeq_6;
 /* __AProcessCtrl_Aexec_O1 */
 PRM(2,__AProcessCtrl_Aexec_O1);
 /* __AProcessCtrl_Awrite */
 PRM(1,__AProcessCtrl_Awrite);
 /* __AProcessCtrl_Aread */
 PRM(0,__AProcessCtrl_Aread);}

